#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include "aim.h"

int xoff = 0, yoff = 0;
int xsiz = 0, ysiz = 0;

static void
reloc(struct image *a, struct image *b)
{
  unsigned char *c = malloc(a->rows * image_rowbytes(a) * 4);
  unsigned char *d = malloc(b->rows * image_rowbytes(b) * 4);
  memset(c, 0, a->rows *image_rowbytes(a) * 4);
  memset(d, 0, b->rows *image_rowbytes(b) * 4);
  for (int y = 0; y < a->rows; y++)
    memcpy(&c[(y+a->rows/2)*image_rowbytes(a)*2 + image_rowbytes(a)/2], &a->bitmap[y*image_rowbytes(a)], image_rowbytes(a));
  for (int y = 0; y < b->rows; y++)
    memcpy(&d[(y+b->rows/2)*image_rowbytes(b)*2 + image_rowbytes(b)/2], &b->bitmap[y*image_rowbytes(b)], image_rowbytes(b));

  xoff += a->cols/2;
  yoff += a->rows/2;

  a->rows *= 2;
  b->rows *= 2;
  a->cols *= 2;
  b->cols *= 2;

  free(a->bitmap);
  free(b->bitmap);

  a->bitmap = c;
  b->bitmap = d;
}

#define UL image_getpixel(in, x-1, y-1)
#define DL image_getpixel(in, x-1, y+1)
#define UR image_getpixel(in, x+1, y-1)
#define DR image_getpixel(in, x+1, y+1)
#define U  image_getpixel(in,   x, y-1)
#define D  image_getpixel(in,   x, y+1)
#define  L image_getpixel(in, x-1,   y)
#define  R image_getpixel(in, x+1,   y)

#define SP(a) image_putpixel(tmp, x, y, a)

uint64_t
exercise(int gen, struct image * restrict in)
{
  xsiz = in->cols;
  ysiz = in->rows;

  struct image *tmp = malloc(sizeof(*tmp));
  tmp->cols = in->cols;
  tmp->rows = in->rows;
  tmp->bitmap = malloc(in->rows * image_rowbytes(in));
  memset(tmp->bitmap, 0, in->rows * image_rowbytes(in));

  for (int g = 0; g < gen; g++) {
    for (int y = 0; y < in->rows; y++)
      if (image_getpixel(in, 0, y) || image_getpixel(in, in->cols-1, y)) {
	reloc(in, tmp);
	goto RUN;
      }

    for (int x = 0; x < in->cols; x++)
      if (image_getpixel(in, x, 0) || image_getpixel(in, x, in->rows-1)) {
	reloc(in, tmp);
	goto RUN;
      }

RUN:
    for (int x = 1; x < in->cols-1; x++) {
      int y = 0;
      if (D + DL + DR == 3)
	SP(1);
      else
	SP(0);

      y = in->rows - 1;
      if (U + UL + UR == 3)
	SP(1);
      else
	SP(0);
    }

    for (int y = 1; y < in->rows-1; y++) {
      int x = 0;
      if (R + DR + UR == 3)
	SP(1);
      else
	SP(0);

      x = in->cols - 1;
      if (L + UL + DL == 3)
	SP(1);
      else
	SP(0);
    }

    for (int y = 1; y < in->rows-1; y++) {
      for (int x = 1; x < in->cols-1; x++) {
	int cnt = U + D + L + R + UL + DR + UR + DL;

	if ((cnt == 3) || (cnt == 2) && (image_getpixel(in, x, y)))
	  SP(1);
	else
	  SP(0);
      }
    }

    struct image *_tmp = tmp;
    tmp = in;
    in = _tmp;

    continue;
    char fn[40];
    sprintf(fn, "tmp%05d", g);
    image_save(fn, in);
  }

  uint64_t cnt = 0;
  for (int y = yoff; y < yoff + ysiz; y++)
    for (int x = xoff; x < xoff + xsiz; x++)
      cnt += image_getpixel(in, x, y);

  image_save("end.pbm", in);
  return cnt;
}
